/***************************************************************************

  CWorkspace.h

  The Workspace class

  (c) 2000-2003 Benot Minisini <gambas@users.sourceforge.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __CWORKSPACE_H
#define __CWORKSPACE_H

#include "gambas.h"
#include "../gb.qt.h"

#include <qptrdict.h>
#include <qworkspace.h>

#ifndef __CWORKSPACE_CPP
extern GB_DESC CWorkspaceDesc[];
extern GB_DESC CWorkspaceChildrenDesc[];
#else

#define WIDGET ((QWorkspace *)((QT_WIDGET *)_object)->widget)
#define THIS ((CWORKSPACE *)_object)

#define CWORKSPACE_PROPERTIES QT_WIDGET_PROPERTIES

#endif

typedef
  struct {
    QT_CONTAINER widget;
    QWidget *active;
    }
  CWORKSPACE;

class CWorkspace : public QObject
{
  Q_OBJECT

public:

  static CWorkspace manager;
  //QPtrDict<QWidget> dict;

public slots:

  void activated(QWidget *);
  void destroyed();
};

#endif
